/*******************************************************************
 *
 * File: play.c
 * 
 * Author: Tomasz Stachowiak
 *
 * Description: Play audio from a file in raw format
 *
 * Date: 07.18.96
 *
 *******************************************************************/


#include <stdio.h>
#include <signal.h>
#include <dmedia/audio.h>

#include "params.h"


ALport speaker;
ALconfig conf;
FILE *file;
void *buf;
void *decompressed_buf;

void print_rate()
{
  long par[2];

  par[0] = AL_OUTPUT_RATE;
  par[1] = 8000;
  ALsetparams(AL_DEFAULT_DEVICE, par, 2);
  ALgetparams(AL_DEFAULT_DEVICE, par, 2);
  printf("Input rate: %d\n", par[1]);
}



main()
{
  print_rate();

  decompressed_buf = malloc(BUF_SIZE);  
  buf = malloc(BLOCK+1);
  file = fopen("micro.audio", "r");

  if ((conf = ALnewconfig()) == 0)
    fprintf (stderr, "Config allocation error\n");
  if (ALsetchannels(conf, MONO) < 0)
    fprintf (stderr, "Setting channel error\n");
  if (ALsetqueuesize(conf, QSIZE) < 0)
    fprintf (stderr, "Setting queue size error\n");
  if (ALsetwidth(conf, AL_SAMPLE_16) < 0)
    fprintf (stderr, "Setting sample width error\n");

  if ((speaker = ALopenport("speaker", "w", conf)) == 0)
    fprintf (stderr, "Port opening error");
 
  while(!feof(file))
    {
      fread(buf, BLOCK+1, 1, file);
      decompress(buf, decompressed_buf, BLOCK);
      ALwritesamps(speaker, decompressed_buf, BLOCK);
    }

  free(buf);
  free(decompressed_buf);
  ALcloseport(speaker);
  fclose(file);
}














